      PROGRAM ODE
C	Solve Ordinary D.E. by RUNGE-KUTTA Method
      PARAMETER( NPTS=51 )
      DIMENSION X(NPTS),Y(NPTS)
      WRITE(*,*) 'Please enter the initial condition'
      READ(*,*) Y0
      WRITE(*,*) 'Please enter the range of X'
      READ(*,*) X0, XN
C   Echo the Input values
      WRITE(*,'(" I.C.:" F7.3,/," Indep. Range: ",F7.3," to ",F7.3)')
     & Y0, X0, XN
      AA = RUNGKUT(X0,XN,Y0,NPTS,X,Y)	!solve the ODE
      DO 10 I=1,NPTS
   10 WRITE(*,*) 'X(',i,') =', X(I), ' Y(',I,') =',Y(I)
      STOP
      END

C     This function solves an Ordinary D. E. of the form:  Y'=F(X,Y)
C       by a 4th Order RUNGE KUTTA technique.
C     The number of points, N, should include the Initial Condition.
C     The solution to the ODE is returned via the arrays X(I) & Y(I).
C     The function is supplied as a statement function, FXY(X,Y)
      FUNCTION RUNGKUT(X0,XN,Y0,N,X,Y)
      DIMENSION X(N),Y(N)
      REAL K1,K2,K3,K4
      FXY(X,Y) = Y+EXP(-X)	! ODE to solve
      H= (XN-X0)/(N-1)	! step size
      Y(1)= Y0
      DO 10 I=1,N-1
      X(I)= X0 + (I-1)*H
      X(I+1)= X(I) + H
      K1=FXY(X(I),Y(I))
      K2=FXY(X(I)+0.5*H,Y(I)+0.5*H*K1)
      K3=FXY(X(I)+0.5*H,Y(I)+0.5*H*K2)
      K4=FXY(X(I+1),Y(I)+H*K3)
   10 Y(I+1) = Y(I) + (H/6.)*(K1 + 2.*K2 + 2.*K3 + K4)
      RUNGKUT = Y(N)	! Return last value of Y
      RETURN
      END
