/* f77ini.c - setup FORTRAN-77 environment in C for code translated
       by FOR_C (TM) from COBALT BLUE
 */
/*
 *    copyright Cobalt Blue, Inc., 1988 - 1996
 *               ALL RIGHTS RESERVED
 */

#include <stdio.h>
#include <stdlib.h>

	/* DEFINITION of Runtime Library EXTERNALS to avoid problems with 
		older Librarians */
#define EXTERNL

#include <fcrt.h>
#include <fcio.h>
#include <complx.h>

					/*	*	*	*	*/

extern int crrgcntl; /* defined in opncls.c */

FILE *rterr_fp;

void f77ini(argc,argv) /*initialize the translated FORTRAN environment*/
int argc;
char *argv[];
{
	void ini_units(), ini_inoutunits();

	/* Record length used w/direct unformatted I/O */
#if defined(unix) || defined(vms) /*32 bit UNIX &/or VMS assumed*/
	reclen_wordsiz = sizeof(float);
#else /*MSDOS*/
	reclen_wordsiz = 1;	/*most DOS F77 compilers assume byte words*/
#endif
	/*NOTE: if reclen_wordsiz is NOT set, then ini_unitstru() will set
	 * it to the sizeof a float.  The FORTRAN-77 standard defines direct
	 * unformatted I/O record lengths in terms of the default word size.
	 * reclen_wordsiz is multiplied by the given record length when opening
	 * a file to obtain the record length in bytes, (see ini_unitstru() in
	 * "opncls.c".
	 */

	/*carriage control*/
	crrgcntl = YES; 
	 /*if YES (1), use col 1 for carriage control on STDOUT_UNIT
	  * else set to NO (0) to disable carriage control
	  */
	 /*(this also applies to the OUT_UNIT (default is 6) defined 
	  *  for compatibility with older FORTRAN.)
	  */

	rterr_fp = RTERR_FP;

	ini_units(); /*initialize the F77 units STDIN_UNIT, STDOUT_UNIT, etc*/
	ini_inoutunits(); /*init. the F77 units IN/OUT_UNIT*/
	milspec = YES; /*indicate the milspec extensions are enabled*/

	blk_data(); /*call any UNnamed block data*/
	blkdata0(); /*call 1st of 5 possible named block datas*/
	blkdata1(); /*call 2nd of 5 possible named block datas*/
	blkdata2(); /*call 3rd of 5 possible named block datas*/
	blkdata3(); /*call 4th of 5 possible named block datas*/
	blkdata4(); /*call 5th of 5 possible named block datas*/

	atexit( free_nts ); /*release the nts[] array on exit*/
		/*added 10/14/96*/
	
	/* perform any other required initialization */
		/* HERE! */
	return;
}

	/*   *   *   *   */

void f_err( msg ) /*output F77 Runtime error msg & quit*/
char *msg;
{
	char emsg[256];
	int u; /*unit index*/

	sprintf( emsg, "FCRT ERROR: %s\n", msg );
	fputs( emsg, rterr_fp );

#ifdef DG_F77
	/*echo message to all errlog units to support DG F77 feature*/
	for( u=0; u < MAX_UNITS; u++ ){
		if( unit_s[u].errlog )
			fputs( emsg, UFP(u) );
		}
#endif

	clos_units(); /*properly close all the units*/
	exit( 1 );
}

void f_warn( msg ) /*output F77 Runtime warning msg & return*/
char *msg;
{
	char wmsg[256];
	int u; /*unit index*/

	sprintf( wmsg, "FCRT WARNING: %s\n", msg );
	fputs( wmsg, rterr_fp );

#ifdef DG_F77
	/*echo message to all errlog units to support DG F77 feature*/
	for( u=0; u < MAX_UNITS; u++ ){
		if( unit_s[u].errlog )
			fputs( wmsg, UFP(u) );
		}
#endif

	return;
}

	/*   *   *   *   */

#ifdef dprod
#undef dprod
#endif

/* NOTE: The user is strongly urged to use the macro version of this funct! */
double dprod( l, r )	/* dbl precision result of 2 sgl precision nos. */
double l, r;
{
	return( l*r );
}

	/*  *  *  *  */

void ck_allocs( aa, n, fname ) /*ck for successful allocations*/
void *aa[]; /*ptrs to the allocated objects*/
unsigned n; /*size of aa[], i.e, the no. of allocs*/
char *fname; /*funct where malloc() occured*/
{
	int i;

	for( i=0; i < n; i++ ){
		if( aa[i] == NULL ){
			char msg[80];
			sprintf( msg, "unable to allocate space in %s()", fname );
			memerr( msg );
			}
		}
	return;
}

void rel_allocs( aa, n ) /*release all allocated objects*/
void *aa[]; /*ptrs to the allocated objects*/
unsigned n;
{
	int i;

	for( i=0; i < n; i++ ){
		if( aa[i] )
			free( aa[i] );
		}
	return;
}

void memerr( msg )
char *msg;
{
	if( rterr_fp==NULL )
		rterr_fp = RTERR_FP; /*insure valid fp (in case re-set)*/
	fputs( "MEM ERROR: ", rterr_fp );
	fputs( msg, rterr_fp );
	fputc( '\n', rterr_fp );
	exit( 1 );
	return; /*not reached*/
}

