#  fcrt.mak -- Make file to build the FOR_C Runtime Library
#         copyright Cobalt Blue, Inc., 1988-1994
#                    ALL RIGHTS RESERVED

# NOTE: THIS MAKEFILE IS DESIGNED TO BE RUN FROM THE 'mkfcrt' SHELL
#       SCRIPT, IN ORDER TO CORRECTLY SET THE MACROS!

# cblue is an environmental variable that should contain the forc directory,
# which in turn contains the FOR_C include files.  'cblue' is normally
# set in ".cshrc" or ".login" on Sun's with the setenv command.  For example,
#             setenv cblue /home/cblue

# Lately, some of the Unix C compilers have started moving towards ANSI C,
# (e.g., Sun's Sparc C compiler under OS v4.1, the SCO UNIX C compiler,
# and IBM's RS6000 'xlc' C compiler).  The headers included with these
# compilers should be used rather than the temporary ones supplied with
# the FOR_C package.  Hence ours have been moved to the cblue/unixsysv
# subdirectory.  If NOT compiling for an ANSI compiler under UNIX, then
# our headers must still be used in compiling the runtime library.  The
# opt macro must then specify the cblue/unixsysv subdirectory.  When using
# the mkfcrt script, this is normally defined for Sun 3, Xenix, and the
# generic settings, but not for Sparcstations and IBM RS6000's. 
# Default
opt=

# If you are not using the standard UNIX C compiler then redefine the cc
# macro as is appropriate.  This will normally be set on the command line
# in the 'mkfcrt' script.
cc=cc

# Default library name
L=fcrt.a
# The library name macro, L, is normally supplied on the command line and
# is dependent on the target machine, AND must correspond to the names
# referenced by the 'cf' script.

# ranlib (if needed)
R=ranlib $L

# the compilation line
compil=$(cc) -I$(cblue) $(opt) -c -O $*.c; ar r $L $*.o; rm $*.o

$L: \
	$L(bitmanip.o) $L(bksp.o)    $L(blkdata.o) $L(blkdata0.o) \
	$L(blkdata1.o) $L(blkdata2.o) $L(blkdata3.o) $L(blkdata4.o) \
	$L(complxf.o)  $L(complx.o)  $L(endfil.o)   \
	$L(f77ini.o)   $L(fmt.o)     $L(fprtunf.o) $L(fscanld.o)  $L(fscanunf.o) \
	$L(inqu.o)     $L(inschr.o)  $L(intio.o)   $L(istrstr.o)  $L(itochr.o)   \
	$L(max.o)      $L(min.o)     $L(mod.o)     $L(ntstr.o)    $L(opncls.o)   \
	$L(pbawraps.o) $L(posdif.o)  $L(powi.o)    $L(readfmt.o)  $L(rountrun.o) \
	$L(sign.o)     $L(sprtunf.o) $L(sscanunf.o) $L(strcmpi.o) $L(strcmpip.o) \
	$L(strlcpy.o)  $L(strlwr.o)  $L(strmgt.o)  $L(strpad.o)   $L(strrev.o)   \
	$L(wrtfmt.o)
	$R
	@echo  "*** $L is now up to date ***" 

$L(bksp.o):     $(cblue)/fcrt.h $(cblue)/fcio.h
	$(compil)
$L(bitmanip.o): $(cblue)/fcrt.h
	$(compil)
$L(blkdata.o):  
	$(compil)
$L(blkdata0.o):
	$(compil)
$L(blkdata1.o):
	$(compil)
$L(blkdata2.o):
	$(compil)
$L(blkdata3.o):
	$(compil)
$L(blkdata4.o):
	$(compil)

$L(complxf.o):	$(cblue)/fcrt.h              $(cblue)/complx.h
	$(compil)
$L(complx.o): 	$(cblue)/fcrt.h              $(cblue)/complx.h
	$(compil)

$L(endfil.o): 	$(cblue)/fcrt.h  $(cblue)/fcio.h
	$(compil)

$L(f77ini.o):	$(cblue)/fcrt.h  $(cblue)/fcio.h
	$(compil)
$L(fmt.o):    	$(cblue)/fcrt.h  $(cblue)/fcio.h
	$(compil)
$L(fprtunf.o):	$(cblue)/fcrt.h  $(cblue)/fcio.h  $(cblue)/complx.h \
	            $(cblue)/unfio.h
	$(compil)
$L(fscanld.o):	$(cblue)/fcrt.h  $(cblue)/fcio.h  $(cblue)/complx.h
	$(compil)
$L(fscanunf.o):	$(cblue)/fcrt.h  $(cblue)/fcio.h  $(cblue)/complx.h \
	            $(cblue)/unfio.h
	$(compil)

$L(inqu.o):   	$(cblue)/fcrt.h  $(cblue)/fcio.h
	$(compil)
$L(inschr.o): 	$(cblue)/fcrt.h  $(cblue)/fcio.h
	$(compil)
$L(intio.o):  	$(cblue)/fcrt.h  $(cblue)/fcio.h
	$(compil)
$L(istrstr.o):	$(cblue)/fcrt.h
	$(compil)
$L(itochr.o): 	$(cblue)/fcrt.h
	$(compil)

$L(max.o):    	$(cblue)/fcrt.h
	$(compil)
$L(min.o):    	$(cblue)/fcrt.h
	$(compil)
$L(mod.o):		$(cblue)/fcrt.h
	$(compil)

$L(ntstr.o):  	$(cblue)/fcrt.h
	$(compil)

$L(opncls.o): 	$(cblue)/fcrt.h  $(cblue)/fcio.h
	$(compil)

$L(pbawraps.o): $(cblue)/fcrt.h
	$(compil)
$L(posdif.o): 	$(cblue)/fcrt.h
	$(compil)
$L(powi.o):   	$(cblue)/fcrt.h
	$(compil)

$L(readfmt.o):	$(cblue)/fcrt.h  $(cblue)/fcio.h  $(cblue)/complx.h
	$(compil)
$L(rountrun.o):	$(cblue)/fcrt.h
	$(compil)

$L(sign.o):   	$(cblue)/fcrt.h
	$(compil)
$L(sprtunf.o):	$(cblue)/fcrt.h $(cblue)/fcio.h $(cblue)/complx.h \
	            $(cblue)/unfio.h
	$(compil)
$L(sscanunf.o):	$(cblue)/fcrt.h $(cblue)/fcio.h $(cblue)/complx.h \
	            $(cblue)/unfio.h
	$(compil)
$L(strcmpi.o):	$(cblue)/fcrt.h
	$(compil)
$L(strcmpip.o):	$(cblue)/fcrt.h
	$(compil)
$L(strlcpy.o):	$(cblue)/fcrt.h
	$(compil)
$L(strlwr.o): 	$(cblue)/fcrt.h
	$(compil)
$L(strmgt.o): 	$(cblue)/fcrt.h
	$(compil)
$L(strpad.o): 	$(cblue)/fcrt.h
	$(compil)
$L(strrev.o):	$(cblue)/fcrt.h
	$(compil)

$L(wrtfmt.o): 	$(cblue)/fcrt.h  $(cblue)/fcio.h
	$(compil)

