/* intio.c - internal F77 I/O emulation for translations made by FOR_C (TM) */
/*
 *    copyright Cobalt Blue, Inc., 1988 - 1992
 *               ALL RIGHTS RESERVED
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <fcrt.h>
#include <fcio.h>

#ifdef PROTOTYPES
void ini_intunit( int, char*, unsigned );	/* internal unit struct init. */
#else
void ini_intunit();
#endif

	/*	*	*	*	*/

void ird_seqbeg( str, recl, fmt )	/* internal read */
char *str;
unsigned recl;
char *fmt;
{

	/* init. unit buf struct */
	*(str+recl) = '\0';	/* null terminate string (insurance) */
	ini_intunit( INTERNAL_UNIT, str, recl );

	/* & init. the format struct */
	io_fmtini( INTERNAL_UNIT, fmt );

	return;
}

	/*	*	*	*	*/

char ill_ssbnds[] = "illegal substr bounds in internal I/O";

void irdsubs_seqbeg( str, start, end, fmt )	/* internal read from substr */
char *str;
unsigned start, end;
char *fmt;
{

	if( end < start )
		f_err( ill_ssbnds ); /*"illegal substr bounds in internal I/O"*/

	/* init. unit buf struct */
	ini_intunit( INTERNAL_UNIT, str+start, end-start+1 );

	/* & init. the format struct */
	io_fmtini( INTERNAL_UNIT, fmt );

	return;
}

	/*	*	*	*	*/

void iwrt_seqbeg( str, recl, fmt )	/* internal write */
char *str;
unsigned recl;
char *fmt;
{

	/* init. unit buf struct */
	*(str+recl) = '\0';	/* null terminate string (insurance) */
	ini_intunit( INTERNAL_UNIT, str, recl );
	unit_s[INTERNAL_UNIT].setbuf = TRUE; /* init. ubuf w/' 's */

	/* & init. the format struct */
	io_fmtini( INTERNAL_UNIT, fmt );

	return;
}

	/*	*	*	*	*/

void iwrtsubs_seqbeg( str, start, end, fmt )	/* internal write to substr */
char *str;
unsigned start, end;
char *fmt;
{

	if( end < start )
		f_err( ill_ssbnds ); /*"illegal substr bounds in internal I/O"*/

	/* init. unit buf struct */
	ini_intunit( INTERNAL_UNIT, str+start, end-start+1 );
	memset( str+start, ' ', end-start+1 );
	 /*NOTE: DON'T null terminate string since its a substr! */

	/* & init. the format struct */
	io_fmtini( INTERNAL_UNIT, fmt );

	return;
}

		/*	*	*	*	*/

F_FORMAT iu_fmt;	/* format struct for the internal unit(s) */


void ini_intunit( u, str, rl )	/* internal unit struct init. */
int u;	/* internal unit to initialize */
char *str;	/* the internal unit buffer */
unsigned rl;	/* the record length */
{

	unit_s[u].fname = "";
	unit_s[u].fp = NULL;
	unit_s[u].f77typ = UNKNOWN;
	unit_s[u].status = 0;	/* reset */

	unit_s[u].access = SEQUENTIAL;	/* by definition */
	unit_s[u].form = FORMATTED;
	unit_s[u].reclen = rl;
	unit_s[u].intu = TRUE;	/* denote INTERNAL unit */

	/* attach str for buffer */
	unit_s[u].ubuf = str;
	unit_s[u].ubufend = unit_s[u].ubuf + unit_s[u].reclen;
	unit_s[u].nxtu = unit_s[u].ubuf;
	unit_s[u].setbuf = FALSE; /* DON'T init. ubuf w/' 's */
	 /*(in case READ or substr write)*/

	unit_s[u].ff = &iu_fmt;	/* attach the internal unit format struct */

	/* set defaults for internal unit */
	unit_s[u].blank  =	BLANK_NULL;
	unit_s[u].ateof	=	NO;
	unit_s[u].ff->cblank =	BLANK_NULL;
	unit_s[u].ff->scalef =	0;
	unit_s[u].ff->signc	=	NORMSIGN;
	return;
}
