/* istrstr.c - char substr location supporting translations by FOR_C (TM) */
/*
 *    copyright Cobalt Blue, Inc., 1988 - 1992
 *               ALL RIGHTS RESERVED
 */


#include <stdio.h>	/* for NULL definition */
#include <string.h>	/* for decl of strstr() */

#include <fcrt.h>

#ifdef NEED_STRSTR
#ifdef PROTOTYPES
	char *strstr(char*,char*);
#else
	char *strstr();
#endif
#endif


int istrstr( str, substr )	/* return the int location of substr in str */
char *str, *substr;
{
	char *s;

	if( substr==NULL || *substr=='\0' )
		return( strlen(str)+1 ); /*from Chuck Ditter of Infinity Graphics,6/93*/
	else if( (s=strstr(str,substr)) == NULL )
		return( 0 );	/* not present */
	return( (int)(s-str) + 1 );
}

long lstrstr( str, substr )	/* return the long int location of substr in str */
char *str, *substr;
{
	char *s;

	if( substr==NULL || *substr=='\0' )
		return( strlen(str)+1 ); /*from Chuck Ditter of Infinity Graphics,6/93*/
	else if( (s=strstr(str,substr)) == NULL )
		return( 0L );	/* not present */
	return( (long)(s-str) + 1L );
}


#ifdef NEED_STRSTR
	/* NOTE: strstr() is part of the Draft ANSI C Standard, however, if
			not present in your std C library, define the above macro switch.
	 */

	char *strstr(str,sub) /* find the first occurrence of 'sub' in 'str' */
	char *str, *sub;
	/* retns a pointer to the start of 'sub' in 'str', or NULL if not present */
	{
	char *s, *b;

	if( sub == NULL || str == NULL )
		return( NULL );
	else if( *sub == '\0' || *str == '\0' )	/* don't deal with null strings */
		return( NULL );

	for( ; *str; str++){
		for( b=str,s=sub; *s == *b  &&  *s ; s++,b++ )
			;
		if( *s == '\0' )	/* match found if the end of 'sub' was reached  */
			return( str );
		if( *b == '\0' )
			break;	/* reached the end of 'str' w/o a match */
		}

	return( NULL );
	}
#endif
