/* max.c - support for F77 max() function variable arg transls by FOR_C (TM) */
/*
 *    copyright Cobalt Blue, Inc., 1988 - 1995
 *               ALL RIGHTS RESERVED
 */



#include <fcrt.h>

#if defined(__STDC__) || ANSI_C_TARGET
#include <stdarg.h>	/* ANSI variable arg macros */
#define VA_START(a,v)	va_start(a,v)
#else
#include <varargs.h>
#define VA_START(a,v)	va_start(a)
#endif

	/* NOTE: These functions guarantee max() problems won't occur due to
			side effects - at the cost of an extra function call. */
#ifdef smax
#undef smax
#endif

#if defined(__STDC__) || ANSI_C_TARGET
	short smax( short a, short b)
#else
	short smax( a, b )
	short a, b;
#endif
	{
		return( a > b ? a : b );
	}

#ifdef max
#undef max
#endif
	long max( a, b )
	long a, b;
	{
		return( a > b ? a : b );
	}

#ifdef fmax
#undef fmax
#endif
	double fmax(a,b)
	double a,b;
	{
		return( a > b ? a : b );
	}

	/* NOTE:
		The vfmaxi(), vfmaxl(), vmaxfi(), & vmaxfl() functions are defined
		as macros (in "fcrt.h") in terms of the basic functions below.

		All of the remaining functions in this file are,
			VARIABLE NUMBER OF ARGRUMENT FUNCTIONS!
	 */


#if defined(__STDC__) || ANSI_C_TARGET
double vfmax( double mx, ... )
#else	/* UNIX System V Variable args */
double vfmax( mx, va_alist )
double mx;			/* (amax1(), dmax1() in F77) */
va_dcl
#endif
{
double a;
va_list args;	/* arg ptr */

if( mx == FEND )
	return( 0. );	/* NULL arg list */

VA_START(args,mx);	/* initialize variable args */

while( (a=va_arg(args,double)) != FEND )
	mx = (mx > a) ? mx : a;

return( mx );
}

	/*		*		*		*		*/

#if defined(__STDC__) || ANSI_C_TARGET
long vmax( long mx, ... )
#else	/* UNIX System V Variable args */
long vmax( mx, va_alist )
long mx;			/* (max0() in F77) */
va_dcl
#endif
{
long a;
va_list args;	/* arg ptr */

if( mx == IEND )
	return( 0L );	/* NULL arg list */

VA_START(args,mx);	/* initialize variable args */

while( (a=va_arg(args,long)) != IEND )
	mx = (mx > a) ? mx : a;

return( mx );
}

	/*		*		*		*		*/

#if defined(__STDC__) || ANSI_C_TARGET
short vsmax( short mx, ... )
#else	/* UNIX System V Variable args */
short vsmax( mx, va_alist )
short mx;			/* (max0() in F77) */
va_dcl
#endif
{
short a;
va_list args;	/* arg ptr */

if( mx == SEND )
	return( 0 );	/* NULL arg list */

VA_START(args,mx);	/* initialize variable args */

while( (a=va_arg(args,short)) != SEND )
	mx = (mx > a) ? mx : a;

return( mx );
}
