/* min.c - support for F77 min() function variable arg transls by FOR_C (TM) */
/*
 *    copyright Cobalt Blue, Inc., 1988 - 1995
 *               ALL RIGHTS RESERVED
 */


#include <fcrt.h>

#if defined(__STDC__) || ANSI_C_TARGET
#include <stdarg.h>	/* ANSI variable arg macros */
#define VA_START(a,v)	va_start(a,v)
#else
#include <varargs.h>
#define VA_START(a,v)	va_start(a)
#endif

	/* NOTE: These functions guarantee min() problems won't occur due to
			side effects - at the cost of an extra function call. */

#ifdef smin
#undef smin
#endif
#if defined(__STDC__) || ANSI_C_TARGET
	short smin( short a, short b )
#else
	short smin( a, b )
	short a, b;
#endif
	{
		return( a < b ? a : b );
	}

#ifdef min
#undef min
#endif
	long min( a, b )
	long a, b;
	{
		return( a < b ? a : b );
	}

#ifdef fmin
#undef fmin
#endif
	double fmin(a,b)
	double a,b;
	{
		return( a < b ? a : b );
	}

	/* NOTE:
		The vfmini(), vfminl(), vminfi(), & vminfl() functions are defined
		as macros (in "fcrt.h") in terms of the basic functions below.

		All of the functions in the rest of this file are,
			VARIABLE NUMBER OF ARGRUMENT FUNCTIONS!
	 */


#if defined(__STDC__) || ANSI_C_TARGET
double vfmin( double mn, ... )
#else	/* UNIX System V C variable args */
double vfmin( mn, va_alist ) /* FLOATING POINT MINIMUM */
double mn;			/* (amin1(), dmin1() in F77) */
va_dcl
#endif
{
double a;
va_list args;	/* arg ptr */

if( mn == FEND )
	return( 0. );	/* NULL arg list */

VA_START(args,mn);	/* initialize variable args */

while( (a=va_arg(args,double)) != FEND )
	mn = (mn < a) ? mn : a;

return( mn );
}

	/*		*		*		*		*/

#if defined(__STDC__) || ANSI_C_TARGET
long vmin( long mn, ... )
#else	/* UNIX System V C variable args */
long vmin( mn, va_alist )
long mn;			/* (min0() in F77) */
va_dcl
#endif
{
long a;
va_list args;	/* arg ptr */

if( mn == IEND )
	return( 0L );	/* NULL arg list */

VA_START(args,mn);	/* initialize variable args */

while( (a=va_arg(args,long)) != IEND )
	mn = (mn < a) ? mn : a;

return( mn );
}

	/*		*		*		*		*/

#if defined(__STDC__) || ANSI_C_TARGET
short vsmin( short mn, ... )
#else	/* UNIX System V C variable args */
short vsmin( mn, va_alist )
short mn;			/* (min0() in F77) */
va_dcl
#endif
{
short a;
va_list args;	/* arg ptr */

if( mn == SEND )
	return( 0 );	/* NULL arg list */

VA_START(args,mn);	/* initialize variable args */

while( (a=va_arg(args,short)) != SEND )
	mn = (mn < a) ? mn : a;

return( mn );
}
