/* rountrun.c - C support for F77 rounding & truncating functions generated
				by FOR_C (TM) from COBALT BLUE
 */
/*
 *    copyright Cobalt Blue, Inc., 1988 - 1996
 *               ALL RIGHTS RESERVED
 */

#include <math.h> /*for modf()*/
#include <fcrt.h>

#ifdef trunc
#undef trunc
#endif

#ifdef fnint
#undef fnint
#endif

	double fnint( f ) /* nearest whole number of float */
	double f;         /* (anint(), dnint() in F77) */
	{
		return( f < 0 ? trunc(f-0.5) : trunc(f+0.5) );
	}
		double fnint_( f )
		double *f;
		{ return fnint(*f); }

		double fnintf_( f )
		float *f;
		{ return fnint(*f); }

#ifdef __alpha	/*DEC ALPHA C also defines nint(), just differently*/
 /*allow macro to rename nint(), see "fcrt.h"*/
#else
# ifdef nint
#	undef nint
# endif
#endif

#ifdef sun
	/* NOTE: Sun's library includes nint() */
#else
	long nint( f ) /* nearest integer */
	double f;      /* (nint(), idnint() in F77) */
	{
		return( (long)(f < 0 ? f-0.5 : f+0.5) );
	}
#endif
		long nint_( f )
		double *f;
		{ return nint(*f); }

		long nintf_( f )
		float *f;
		{ return nint(*f); }

#ifdef snint
#undef snint
#endif

	short snint( f ) /* nearest integer */
	double f;        /* (nint(), idnint() in F77) */
	{
		return( (short)(f < 0 ? f-0.5 : f+0.5) );
	}
		short snint_( f )
		double *f;
		{ return snint(*f); }

		short snintf_( f )
		float *f;
		{ return snint(*f); }


#ifdef trunc
#undef trunc
#endif

	double trunc( f ) /* truncation */
	double f;         /* (aint(), dint() in F77) */
	{
		double n;
		f = modf(f,&n); /* split into fractional & whole parts */
		                /* (fraction junked) */
		return( n );    /* return whole part */
	}
		double trunc_( f )
		double *f;
		{ return trunc(*f); }

		double truncf_( f )
		float *f;
		{ return trunc(*f); }
