/* sign.c - support for F77 sign() function translations by FOR_C (TM) */
/*
 *    copyright Cobalt Blue, Inc., 1988 - 1996
 *               ALL RIGHTS RESERVED
 */


#include <fcrt.h>

#ifdef ssign
#undef ssign
#endif

#if defined(__STDC__) || ANSI_C_TARGET
	short ssign( short a, short b )		/* short integer sign transfer */
#else
	short ssign( a, b )		/* short integer sign transfer */
	short a, b;				/* (isign() in F77) */
#endif
	{
		return( b < 0 ? -_ABS_(a) : _ABS_(a) );
	}
		short ssign_( a, b )
		short *a, *b;
		{ return ssign(*a,*b); }

#ifdef isign
#undef isign
#endif

	long isign( a, b )		/* long int sign transfer */
	long a, b;				/* (isign() in F77) */
	{
		return( b < 0L ? -_ABS_(a) : _ABS_(a) );
	}
		long isign_(a,b)
		long *a,*b;
		{ return isign(*a,*b); }

#ifdef sign
#undef sign
#endif

	double sign( a, b )		/* floating point sign transfer */
	double a, b;			/* (sign(), dsign() in F77) */
	{
		return( b < 0 ? -_ABS_(a) : _ABS_(a) );
	}
		double sign_(a,b)
		double *a,*b;
		{ return sign(*a,*b); }

		double signf_(a,b)
		float *a,*b;
		{ return sign(*a,*b); }
