/* strcmpi.c - case insensitive string comparison -	by COBALT BLUE */

#include <ctype.h>
#include <stddef.h>
#include <fcrt.h>	/* for def. of TOLOWER() */

int strcmpi( r, s )	/* compare the two strings r & s, retn 0 if the same */
const char *r, *s;		/* (case insensitive comparison done) */
{
	/* retns	+int	if r is lexically greater than s
				  0 	if r is lexically equal to s
				-int	if r is lexically less than s
	 */

	if( r == s )
		return( 0 );	/* both null, or both the same address */

	if( r == NULL || s == NULL )
		return( r ? 1 : -1 );

	/* both non-null and different addresses */
	for( ; *r && *s ; r++,s++ ){
		if( TOLOWER(*r) != TOLOWER(*s) )
			break;
		}

	return( TOLOWER(*r) - TOLOWER(*s) );
}

