/* strcmpip.c - string compare ignoring case & blank padding
 */
/*
 *    copyright Cobalt Blue, Inc., 1988 - 1992
 *               ALL RIGHTS RESERVED
 */

#include <stddef.h>
#include <fcrt.h>


	/*		*		*		*		*/

int strcmpip(left, right) /*str compare ignoring case & blank padding*/
const char *left, *right;	/* retns <0 if l < r, 0 if equal, or >0 if l > r */
{
/* strcmpip() effectively blank fills the shorter str for 
	the comparison, but otherwise functions the same as strcmpi() */
int l, r;

	if( left == right )
		return( 0 );

	if( left==NULL || right==NULL )
		return( right ? 1 : -1 );

	while( *left || *right ){
		l = *left ? *left++ : ' ';
		r = *right ? *right++ : ' ';
		l = TOLOWER( l );
		r = TOLOWER( r );
		if( l != r )
			return( l - r );
		}

	return( 0 );	/* equal strings */
}
